var ApiClient = function () {

  this.host = window.browser.getHost();

}

ApiClient.prototype = {

  host: null,
  loginTabId: null,
  isAuthenticated: true,

  request: function (args, callback, errorCallback) {

    // args = {type:, uri:, data:, context:}

    // Check for the session cookie before making a request
    window.browser.getCookie({url: this.host, name: 'sessionid'}, function (obj, args, callback, errorCallback) {
      return function (cookie) {
        if (!cookie) {
          obj.authFailed();
          return;
        }
        window.browser.ajaxRequest(
          obj.host,
          args,
          function (obj, callback) {
            return function (response) {
              if (!obj.isAuthenticated) {
                obj.restoreSession();
              }
              callback(response);
            }
          }(obj, callback),
          function (obj, errorCallback) {
            return function (xhr) {
              if (xhr.status == 401) {
                obj.authFailed();
              }
              else if (xhr.status == 400) {
                var errors = JSON.parse(xhr.responseText);
                errorCallback(errors);
              }
              else if (xhr.status == 404) {
                errorCallback('Not Found');
              }
            }
          }(obj, errorCallback)
        );
      }
    }(this, args, callback, errorCallback));

  },

  // Series of steps to take when auth fails
  authFailed: function () {

    // Close the toolbar on all pages from the background script
    window.backgroundToolbar.close();

    // Delete the session cookie to block future requests
    window.browser.removeCookie({url: window.api.host, name: 'sessionid'});

    // Grey out the annotary icon
    this.isAuthenticated = false;
    window.browser.setIcon({path: '/icon_grey.png'});

  },

  // Opens up a tab with the login page so the user can log in again
  loginPage: function () {

    window.browser.createOrOpenLoginTab();

  },

  restoreSession: function () {

    this.isAuthenticated = true;
    // Close the login tab
    if (this.loginTabId) {
      window.browser.closeTab(this.loginTabId);
      this.loginTabId = null;
    }
    // Re-register bookmarks on all open pages
    window.messenger.sendRequest({type: 'func', inst: 'bookmarkRegistry', func: 'registerUrlBookmarks'});
    // Light up the icon again
    window.browser.setIcon({path: '/icon.png'});
    // Re-open the toolbar
    window.backgroundToolbar.open();

  }

}
