function BackgroundToolbar() {

  // TODO: Get the most recent collection ID and delete placeholder below
  this.workingCollectionId = 3;

}

BackgroundToolbar.prototype = {

  isOpen: false,
  workingCollectionId: null,

  open: function (mode, tabId) {

    if (this.isOpen == true)
      return;

    window.messenger.sendRequest({type: 'func', inst: 'contentToolbar', func: 'open'}, function (mode, tabId) {
      return function (responseTabId, response) {
        // In the specified tab, set the specified mode
        if (responseTabId == tabId && mode == 'bookmark')
          window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'contentToolbar', func: 'toggleBookmarkMode'});
        else if (responseTabId == tabId && mode == 'highlight')
          window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'contentToolbar', func: 'toggleHighlightMode'});
        else if (responseTabId == tabId && mode == 'network')
          window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'contentToolbar', func: 'toggleNetworkMode', args: ['onStateOnly']});
      }
    }(mode, tabId));

    this.isOpen = true;

  },

  close: function () {

    if (this.isOpen == false)
      return;

    window.messenger.sendRequest({type: 'func', inst: 'contentToolbar', func: 'close'});
    this.isOpen = false;

  },

  toggle: function (mode, tabId) {

    if (this.isOpen)
      this.close();
    else
      this.open(mode, tabId);

  },

  networkMode: function (tabId) {

    if (this.isOpen == false)
      return this.open('network', tabId);

    // Open network mode in just the selected tab
    window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'contentToolbar', func: 'toggleNetworkMode', args: ['onStateOnly']});

  },

  setWorkingCollectionId: function (id) {

    this.workingCollectionId = id;

  }

}
