function BrowserButton () {

  window.browser.setBrowserButtonListener(function (obj) {
    return function(tab) {

      window.browser.getCookie({url: window.api.host, name: 'sessionid'}, function (obj, tab) {
        return function (cookie) {

          // If there's no active session, open up a tab with the login page
          if (!cookie || !window.api.isAuthenticated)
            return window.api.loginPage();

          // If this is the new tab page, make the new tab go to my profile on annotary
          if (window.browser.isNewTab(tab)) {
            window.browser.updateTab(tab, {url: 'https://annotary.com/profiles/me?utm_source=direct&utm_medium=extension'});
            return;
          }

          // Otherwise...

          // Save the selection in the current tab so it gets highlighted once the toolbar opens or once the bookmark is set
          var tabId = window.browser.getTabId(tab);
          window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'contentToolbar', func: 'saveSelection'}, function (tabId) {
            return function () {
              window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'bookmarkRegistry', func: 'showingSomeoneElsesBookmark'}, function (tabId) {
                return function (showingSomeoneElsesBookmark) {
                  // If we're displaying someone else's bookmark in the tab, open it without specifying a mode (the content toolbar opens all tabs showing highlights in network mode)
                  if (showingSomeoneElsesBookmark)
                    window.backgroundToolbar.toggle(null, tabId);
                  else {
                    window.messenger.sendSingleTabRequest(tabId, {type: 'func', inst: 'bookmarkRegistry', func: 'iHaveBookmarked'}, function (tabId) {
                      return function (isBookmarked) {
                        // If it's bookmarked, open up the toolbar with highlight mode in the active tab
                        if (isBookmarked)
                          window.backgroundToolbar.toggle('highlight', tabId);
                        // If not, open the toolbar with bookmark mode in the active tab
                        else
                          window.backgroundToolbar.toggle('bookmark', tabId);
                      }
                    }(tabId));
                  }
                }
              }(tabId));
            }
          }(tabId));

        }
      }(obj, tab));

    }
  }(this));

}

BrowserButton.prototype = {

}
