// Don't execute in iframes
if (window.top === window) {

  browser = window.browser = new BrowserApi();
  messenger = window.messenger = new ContentMessenger();
  api = window.api = new ContentApiClient();
  bookmarkRegistry = window.bookmarkRegistry = new BookmarkRegistry();
  contentToolbar = window.contentToolbar = new ContentToolbar();
  highlighter = window.highlighter = new ContentHighlighter();

  // On the annotary site, remove the missing extension indicator
  if (document.domain && document.domain.match(/^[^.]*\.?annotary.com$/i) != null) {
    $('#extension-missing').remove();
  }

  // If this is the annotary view bookmark page, redirect to the bookmark url with details about the bookmark and highlight selected
  if (document.URL && document.URL.split('?')[0].match(/^https?:\/\/[^.]*\.?annotary\.com\/bookmarks\/[0-9]+\/?.*$/i) != null) {
    var bookmark_url = $('#bookmark-data').attr('data-url');
    var args = {
      id: $('#bookmark-data').attr('data-id'),
      slug: $('#bookmark-data').attr('data-slug')
    }
    var highlight_id = $('#bookmark-data').attr('data-highlight');
    if (highlight_id)
      args.highlight = highlight_id;
    window.messenger.sendRequest({type: 'data', inst: 'api', attr: 'isAuthenticated'}, function (isAuthenticated) {
      if (!isAuthenticated) {
        $('#annotary-bookmark-header').addClass('force-show');
        $('#annotary-bookmark-content').addClass('force-show');
        return;
      }
      window.messenger.sendRequest({type: 'func', inst: 'linkRegistry', func: 'register', args: [bookmark_url.toLowerCase(), args]}, function (bookmark_url) {
        return function () {
          window.location.replace(bookmark_url);
        }
      }(bookmark_url));
    });
  }
  // If this is the annotary signup/install extension page, redirect to my profile
  else if (document.URL && document.URL.match(/^https?:\/\/[^.]*\.?annotary\.com\/signup\/install$/i) != null) {
    window.location.replace('https://annotary.com/profiles/me');
  }
  // If this is the firefox installation page with the close_on_install hash set, close the tab
  else if (document.URL && document.URL.match(/^https?:\/\/addons\.mozilla\.org\/en-US\/firefox\/addon\/annotary-toolbar/i) != null && window.location.hash == '#close_on_install') {
    window.messenger.sendRequest({type: 'func', inst: 'browser', func: 'closeTab', args: ['__tab__']});
  }
  // Otherwise register all of the bookmarks that apply to this URL
  else {
    window.bookmarkRegistry.registerUrlBookmarks();
  }

  if (document.URL)
    $('body').append('<div id="annotary-scripts-loaded"></div>');

}
