ContentMessenger = function () {

  // Init listener for messages from background scripts
  window.browser.setMessageListener(function (obj) {
    return function(request, sender, sendResponse) {
      obj.handleRequest(request, sender, sendResponse);
    }
  }(this));

}

ContentMessenger.prototype = {

  nextRequestId: 0,

  // Handles a request from a background script
  handleRequest: function (request, sender, sendResponse) {

    if (request.type == 'func') {
      var args = request.args ? request.args : [];
      response = window[request.inst][request.func].apply(window[request.inst],args);
    }

    else if (request.type == 'data')
      response = window[request.inst][request.attr];

    sendResponse(response);

  },

  // Sends a message to the background script
  sendRequest: function (request, callback) {

    if (!callback)
      callback = function () {}

    request.id = this.nextRequestId++;

    window.browser.sendBackgroundRequest(request, callback);

  }

}
